#!/usr/bin/perl
use strict;

use Getopt::Std ;

# ----- Check command-line arguments
my %opts = ();
getopts("g:i:n:c:o:s:p:",\%opts);
foreach my $key ("g","i","n","s","c","o")  {
  unless ( exists $opts{$key} )  {
    printf "error: option %s is required\n", $key;
    exit(1);
  }
}

# ----- Write parameter file
my $parfile = $opts{"o"} . ".par";
open(PAR,">$parfile") || die("Unable to open parameter file for writing\n");
printf PAR "genotypefile:%s\n", $opts{"g"};
printf PAR "indivfile:%s\n", $opts{"i"};
printf PAR "covarfile:%s\n", $opts{"c"};
printf PAR "scoreoutfile:%s\n", $opts{"o"};
printf PAR "snpfile:%s\n", $opts{"s"};
printf PAR "ncovars:%s\n", $opts{"n"};
if ( exists $opts{"p"} )  {
  printf PAR "posteriormeanfile:%s\n", $opts{"p"};
}
close(PAR);

# ----- Run ltscore
my $cmd = "../bin/ltscore $parfile";
system("$cmd");
