#ifndef _LTPREV_
#define _LTPREV_

#include <iostream>
#include <cstdlib>
#include <cmath>

#include "IOHandler2.h"     // use to read input file

class LTPrev  {

  public:

    LTPrev()  {  };

    int unpack(IOHandler *ioh);
    int run(IOHandler *ioh);

  private:

    int inverse(double y, double *result);
    double dnorm(double x);
    double pnorm(double x, double mu, double sigma, int lower_tail);
    int readGenotype(int *g, int n, ifstream *gin);
    double minimize(int *ierr);
    double f(double x);

    int ninds;
    int *pheno;          // phenotype (0, 1, 9)
    double prevalence;

    double mthreshold;
    double fcase;
    double fctrl;
    double fexp;

};

#endif
