#include "Invert.h"

#include <iostream>
#include <iomanip>

using namespace std;

Invert::Invert(double *A, int n)  {

  gsl_matrix *amat = gsl_matrix_alloc(n,n); 
  gsl_matrix *aimat = gsl_matrix_alloc(n,n);
  gsl_permutation *p = gsl_permutation_alloc(n);

  for(int i=0;i<n;i++)  {
    for(int j=0;j<n;j++)  {
      gsl_matrix_set(amat,i,j,A[i*n+j]);
    }
  }
  gsl_permutation_init(p);

  int signum;
  int stat = gsl_linalg_LU_decomp(amat,p,&signum);
  if ( stat )  {
    cout << "error: " << gsl_strerror(stat) << endl;
    exit(1);
  }

  stat = gsl_linalg_LU_invert(amat,p,aimat);
  if ( stat )  {
    cout << "error: " << gsl_strerror(stat) << endl;
    exit(1);
  }

  for(int i=0;i<n;i++)  {
    for(int j=0;j<n;j++)  {
      A[i*n+j] = gsl_matrix_get(aimat,i,j);
    }
  }

  gsl_matrix_free(amat);
  gsl_matrix_free(aimat);
  gsl_permutation_free(p);

}

