#include <iostream>
#include <cstdlib>

#include "IOHandler.h"
#include "LTScore.h"

using namespace std;

int main(int argc, char **argv)  {

  if ( argc != 2 )  {
    cout << "usage:  ltscore <parameter-file>" << endl;
    return 1;
  }

  IOHandler ioh;

  // read parameter file
  if ( ioh.readParamFile(argv[1]) )  {
    cerr << "aborted" << endl;
    exit(1);
  }

  // read .ind file
  if ( ioh.readIndFile() )  {
    cerr << "error reading input file" << endl;
    exit(1);
  }

  // read .evec file
  if ( ioh.readEvecFile())  {
    cerr << "error reading evec file" << endl;
    exit(1);
  }

  // read .covar file
  if ( ioh.readCovariateParameters() )  {
    cerr << "error reading covariate parameter file" << endl;
    exit(1);
  }

  LTScore lts;
  lts.unpackData(&ioh);
  lts.run(&ioh);

  return 0;

}
